/*
Ksztette: Szalayn Tahy Zsuzsanna
Neptun kd: N0CD19
E-mail: sztzs@inf.elte.hu
Feladat: Tantrgyfeloszts (rettsgi 2019-05i emelt 4.)
*/
#include <iostream>
#include <fstream>
#include <vector>
using namespace std;
//#define biro

struct EduRec {
	string Teacher;
	string Subject;
	string Group;
	unsigned HoursNum;
};

//input
const unsigned MHours = 40;
const unsigned MaxRec = 1000;
EduRec course[MaxRec + 1];
string name;    //Q3: name of a teacher
string subject; //Q5:
string group;   //Q5


//output
unsigned line;              //number of data lines (N*4)
unsigned N;                 //Q1: number of EduRec records
int hours_sum;              //Q2: weekly sum of hours
int teacher_hours_sum;      //Q3: weekly sum of hours of the named teacher
string outfile = "of.txt";  //Q4: file for the form-master's list
vector<string> groups;      //Q4: list of form-master
const string grouptype[3]   //Q5: expected answers
    = {"Nem tanuljak", "Osztalyszinten tanuljak","Csoportbontasban tanuljak"};
int gt;                     //Q5: index of grouptype
int teacher_count;          //Q6: number of teachers

/*                      Input functions                      */
//menu for the input mode
string inputmenu();

//if all characters are numbers then convert to int
bool str_is_int(string, unsigned&);

//check the answer of the input mode
char answer(string v);

//check the number of line (number of records = lines / 4)
bool line_num_fail(unsigned);

//read 1 record without testing
void inputone_n(int);

//read and test 1 record
bool inputone_y(int);

//input a list of records - from console, given number of items, nontested
//basic "biro" input style
void biroinput(unsigned);

//input a list of records - from console, given number of items, tested
//"biro + test" returns the number of success reading
unsigned testinput(unsigned);

//choosed input process
void input(char);

/*                      Processor functions                      */
//checked parameter input
string data(char, string);
void processing(char);

/*                         Output functions                        */
void output(char);

/*                              MAIN                                */

int main()
{
	string inputmode = inputmenu();
	char processtype; /*in {y, n, x}*/
	/*bool szam = */
	str_is_int(inputmode, line);
#ifdef biro     //	if(szam) {
	processtype = 'n';
	N = line / 4;
	biroinput(N);
#else           //	} else {
	processtype = answer(inputmode);
	if(processtype != 'x')
		input(processtype);
	else
		N = 0;
#endif // biro  //	}
	processing(processtype);

	output(processtype);

	if(processtype == 'y')
		system("pause");

	return 0;
}


/*                      output function's definition                       */

void output(char proctype)
{
	if(proctype != 'x') {
		cout << "#"<< endl;
		cerr << "1. feladat" << endl;
		cerr << "rekordok szama: ";
		cout << N << endl;
		cout << "#"<< endl;
		cerr << "2. feladat" << endl;
		cerr << "az iskolaban a heti osszoraszam: ";
		cout << hours_sum << endl;
		cout << "#" << endl;
		cerr << "3. feladat" << endl;
		cerr << "A tanar heti oraszama: ";
		cout << teacher_hours_sum << endl;
		cout << "#" << endl;
		cerr << "4. feladat" << endl;
		cerr << "osztalyfonokok:" << endl;
		for(unsigned i = 0; i < groups.size(); i++) {
			cout << groups[i] << endl;
		}
		if(proctype == 'y') {
			ofstream fout(outfile.c_str());
			for(unsigned i = 0; i < groups.size(); i++)
				fout << groups[i] << endl;
			fout.close();
		}
		cout << "#" << endl;
		cerr << "5. feladat"<< endl;
		cout << grouptype[gt] << endl;
		cout << "#" << endl;
		cerr << "6. feladat" << endl;
		cerr << "tanarok szama: ";
		cout << teacher_count << endl;
	}
}

/*                      processor function's definition                      */

//checked parameter input
string data(char proctype, string field)
{
	string question[4] = {"egy tanar neve = ", "tantargy = ", "osztaly = ", "!!! programhiba !!!"};
	string err[4] = { "Ismeretlen tanar. Kerem, adja meg ujra: ",
	                  "Nem letezo tantargy. Kerem, adja meg ujra: ",
	                  "Nincs ilyen nevu osztaly. Kerem, adja meg ujra: ",
	                  " "
	                };
	string prop[4] = {"Teacher", "Subject", "Group", " "};
	int t;
	for(t = 0; t < 3 && prop[t] != field; t++)
		;
	string adata = "";
	cerr << question[t];
	if(proctype == 'n') {
		getline(cin, adata);
	} else { /* if(proctype == 'y') */
		bool ready = false;
		unsigned w;
		string dat;
		do {
			getline(cin, adata);
			w = 0;
			do {
				w++;
				switch (t) {
					case 0:
						dat = course[w].Teacher;
						break;
					case 1:
						dat = course[w].Subject;
						break;
					case 2:
						dat = course[w].Group;
						break;
					default:
						dat = "";
						break;
				}
			} while (w <= N && dat != adata);
			if(w <= N)
				ready = true;
			else
				cerr << err[t];
		} while(!ready);
	}
	return adata;
}

void processing(char proctype)
{
	hours_sum = 0;                                          /*Q2*/
	teacher_hours_sum = 0;                                  /*Q3*/
	gt = 0;                                                 /*Q5*/
	teacher_count = 0;                                      /*Q6*/

	if(proctype != 'x') {
		cerr << "Tanari oraszamhoz ";
		name = data(proctype, "Teacher");

		cerr << "Csoportbontas jellemzesehez" << endl;
		group = data(proctype, "Group");
		subject = data(proctype, "Subject");

		vector<string> teachers;                            /*Q6*/

		for(unsigned i = 1; i <= N; i++) {
			hours_sum += course[i].HoursNum;                /*Q2*/

			if(course[i].Teacher == name)                   /*Q3*/
				teacher_hours_sum += course[i].HoursNum;

			if(course[i].Subject == "osztalyfonoki")        /*Q4*/
				groups.push_back(course[i].Group + " - " + course[i].Teacher);

			if(course[i].Group == group && course[i].Subject == subject) /*Q5*/
				gt++;

			unsigned t = 0;                                 /*Q6*/
			while(t < teachers.size() && teachers[t] != course[i].Teacher)
				t++;
			if(t == teachers.size())
				teachers.push_back(course[i].Teacher);
		}

		if(gt > 2)
			gt = 2;
		teacher_count = teachers.size();
	}
}

/*                      input function's definitions                      */

//menu for the input mode
string inputmenu()
{
	cerr << "A tantargyfelosztas elemzese" << endl;
	cerr << "Valasszon az alabbi beolvasasi lehetosegek kozul:" << endl << endl;
	cerr << "\t\tEgy SZAM beirasaval (vegen enter) a 'biro' stilusu konzolos kiertekeles indul." << endl << endl;
	cerr << "\t\tn|N\t konzolrol adott szamu rekord beolvasasa ellenorzes nelkul." << endl;
	cerr << "\t\ty|Y\t konzolrol adott szamu rekord beolvasasa adatonkent ellenorizve." << endl;

	cerr << "A fentiektol eltero kezdetu valaszokra a program futasa vegeter." << endl << endl;

	cerr << "valasztas: ";
	string mode;
	getline(cin, mode);
	cerr << "***************************************************************************************************" <<endl<<endl;
	return mode;
}

//if all characters are numbers then convert to int
bool str_is_int(string s, unsigned& i)
{
	unsigned tmp=0;
	unsigned v;
	for(v = 0; v < s.size() && isdigit(s[v]); v++) {
		tmp = tmp * 10 + s[v]-'0';
	}
	if(v == s.size())
		i = tmp;
	return (v == s.size());
}

//check the answer of the input mode
char answer(string v)
{
	char c;
	bool ok = true;
	if(v.size() == 0)
		ok = false;
	else
		c = tolower(v[0]);
	return (ok && (c == 'n' || c == 'y'))? c : 'x';
}

//check the number of line: number of record <- line / 4
bool line_num_fail(unsigned lnum)
{
	bool ok = true;
	if(lnum > MaxRec * 4) {
		ok = false;
		cerr << "Tul sok a beolvasando adat. (" << lnum << " > " << MaxRec << ")" << endl;
	}
	if(lnum < 4) {
		ok = false;
		cerr << "Tul keves a beolvasando adat. (" << lnum << " < 4)" << endl;
	}
	if(lnum %4 != 0) {
		ok = false;
		cerr << "Az adatok nem adnak ki teljes rekordokat. (" << lnum << "-nak nem osztoja a 4.)"<< endl;
	}
	return !ok;
}

//read 1 record without testing
void inputone_n(int i)
{
	string qka;
	getline(cin, course[i].Teacher);
	getline(cin, course[i].Subject);
	getline(cin, course[i].Group);
	cin >> course[i].HoursNum;
	getline(cin, qka); //read to endline
}

//unchecked database input
void biroinput(unsigned n)
{
	for(unsigned i = 1; i <= n; i++)
		inputone_n(i);
	cerr << "A megaodtt " << n << " bejegyzes teszteles nelkul beolvasva" << endl;
}

//read and test 1 record
bool inputone_y(int i)
{
	bool ok = true;
	string text[4] = {"Tanar nev = ", "Tantargy nev = ", "Osztaly nev= ", "Oraszam = "};
	string temp[4];
	unsigned tmp;
	for(unsigned t = 0; ok && t < 4; t++) {
		cerr << text[t];
		getline(cin, temp[t]);
		if(cin.fail() || temp[t].size() == 0) {
			ok = false;
			cin.clear();
		}
	}
	if(ok) {
		ok = str_is_int(temp[3], tmp);
		if (ok) {
			//between distance learning and weekly working time
			ok = (0 <= tmp && tmp <= MHours);
			if(ok)
				course[i] = {temp[0], temp[1], temp[2], tmp};
			else
				cerr << "Irrealis oraszam" << endl;
		}
	}
	return ok;
}

unsigned testinput(unsigned n)
{
	bool next = true;
	unsigned db;
	for (db = 1; next && db<=n; db++)
		while (next && !inputone_y(db)) {
			cerr << "Hibas rekord." << endl;
			cerr << "\t\tKilepes a bevitelbol: x" << endl;
			cerr << "\t\tRekord ismetlese:     ENTER" << endl;
			string qka;
			getline(cin, qka);
			next = (qka.size() == 0 || qka[0] != 'x');
		}
	db--;     //for(1...db++)
	if(!next)
		db--; //drop the last, not finalized record
	cerr << n << " db vart bejegyzesbol sikeresen beolvasott rekordok szama: ";
	cerr << db << endl;
	return db;
}

//choosed special input process
void input(char proctype)
{
	string stmp;
	cerr << "Adja meg a beolvasando adatok (4-gyel oszthato) szamat: ";
	getline(cin, stmp);
	bool ok = str_is_int(stmp, line);
	while(!ok || line_num_fail(line)) {
		cerr << "Kerem az adatsorok szamat [4; " << MaxRec * 4 << "]: ";
		getline(cin, stmp);
		ok = str_is_int(stmp, line);
	}
	if (proctype == 'n') {
		N = line / 4;
		biroinput(N);
	} else { /*if(proctype == 'y')*/
		N = testinput(line/4);
		if(N != line/4)
			cerr<< "FIGYELMEZTETES: A megadottnal kevesebb rekordot sikerult beolvasni." << endl;
	}
}
